import { AnimationEvent } from '@angular/animations';
import { CdkConnectedOverlay, CdkOverlayOrigin, ConnectedOverlayPositionChange, ConnectionPositionPair } from '@angular/cdk/overlay';
import { ElementRef, EventEmitter, Renderer2 } from '@angular/core';
import 'rxjs/add/observable/of';
import 'rxjs/add/operator/debounceTime';
import 'rxjs/add/operator/do';
import 'rxjs/add/operator/filter';
import { NtOverlayPosition } from './overlay-positions';
export declare type NtOverlayTriggerType = '' | 'hover' | 'click';
export declare class NtOverlayComponent {
    private _renderer;
    private _elementRef;
    private _isOpen;
    private _isMouseIn;
    private _origin;
    private _position;
    private _positionPairs;
    private _paddingClass;
    private _arrow;
    private _noSpacing;
    private _trigger;
    private _overlayClass;
    private _fixed;
    private _closeEvent;
    private _positionChange;
    readonly isOpen: boolean;
    readonly isMouseIn: boolean;
    origin: CdkOverlayOrigin;
    position: NtOverlayPosition;
    readonly positions: ConnectionPositionPair[];
    readonly paddingClass: string;
    fixed: boolean;
    arrow: boolean;
    noSpacing: boolean;
    trigger: NtOverlayTriggerType;
    overlayClass: string;
    cdkConnectedOverlay: CdkConnectedOverlay;
    afterOpen: EventEmitter<any>;
    afterClosed: EventEmitter<any>;
    beforeOpen: EventEmitter<any>;
    beforeClosed: EventEmitter<any>;
    positionChange: EventEmitter<ConnectedOverlayPositionChange>;
    constructor(_renderer: Renderer2, _elementRef: ElementRef);
    private _setPosition();
    private getPosition(value);
    show(): void;
    hide(): void;
    click(): void;
    onOverlayPositionChange(event: ConnectedOverlayPositionChange): void;
    onMouseEnter(): void;
    onMouseLeave(): void;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationDone(event: AnimationEvent): void;
}
