import { Component, Input, NgModule } from '@angular/core';
import { coerceNumberProperty } from '@angular/cdk/coercion';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtProgressCircleComponent {
    constructor() {
        this._max = 100;
        this._value = 0;
        this.size = 'medium';
        this.color = '';
        this.class = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set max(value) { this._max = coerceNumberProperty(value, 100); }
    /**
     * @return {?}
     */
    get max() { return this._max; }
    /**
     * @param {?} value
     * @return {?}
     */
    set value(value) { this._value = coerceNumberProperty(value); }
    /**
     * @return {?}
     */
    get value() { return this._value; }
    /**
     * @return {?}
     */
    get percent() {
        return this.value / this.max * 100;
    }
}
NtProgressCircleComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-progress-circle',
                template: "<div class=\"nt-progress-circle-meter\" [class.half]=\"percent < 50\"> <div class=\"nt-circle-half nt-circle-left\" [style.transform]=\"'rotate(' + (percent > 100 ? 100 : percent) * 3.6 + 'deg)'\"></div> <div class=\"nt-circle-half nt-circle-right\"></div> </div> <div class=\"nt-progress-circle-inner\"><ng-content></ng-content></div> ",
                host: {
                    '[class]': '["nt-progress-circle", color, size, class].join(" ")'
                }
            },] },
];
/** @nocollapse */
NtProgressCircleComponent.propDecorators = {
    "max": [{ type: Input },],
    "value": [{ type: Input },],
    "size": [{ type: Input },],
    "color": [{ type: Input },],
    "class": [{ type: Input },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtProgressComponent {
    constructor() {
        this._max = 100;
        this._value = 0;
        this.size = 'medium';
        this.color = '';
        this.class = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set max(value) { this._max = coerceNumberProperty(value, 100); }
    /**
     * @return {?}
     */
    get max() { return this._max; }
    /**
     * @param {?} value
     * @return {?}
     */
    set value(value) { this._value = coerceNumberProperty(value); }
    /**
     * @return {?}
     */
    get value() { return this._value; }
    /**
     * @return {?}
     */
    get percent() {
        const /** @type {?} */ percent = this.value / this.max * 100;
        return percent > 100 ? 100 : percent;
    }
}
NtProgressComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-progress',
                template: "<span class=\"progress-meter\" [style.width.%]=\"percent > 100 ? 100 : percent\"> <p class=\"progress-meter-text\"><ng-content></ng-content></p> </span> ",
                host: {
                    '[class]': '["progress", color, size, class].join(" ")'
                }
            },] },
];
/** @nocollapse */
NtProgressComponent.propDecorators = {
    "max": [{ type: Input },],
    "value": [{ type: Input },],
    "size": [{ type: Input },],
    "color": [{ type: Input },],
    "class": [{ type: Input },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NtProgressModule {
}
NtProgressModule.decorators = [
    { type: NgModule, args: [{
                exports: [NtProgressComponent, NtProgressCircleComponent],
                declarations: [NtProgressComponent, NtProgressCircleComponent]
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { NtProgressModule, NtProgressComponent, NtProgressCircleComponent };
//# sourceMappingURL=progress.js.map
