import { Component, Input, NgModule } from '@angular/core';
import { coerceNumberProperty } from '@angular/cdk/coercion';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtProgressCircleComponent = /** @class */ (function () {
    function NtProgressCircleComponent() {
        this._max = 100;
        this._value = 0;
        this.size = 'medium';
        this.color = '';
        this.class = '';
    }
    Object.defineProperty(NtProgressCircleComponent.prototype, "max", {
        get: /**
         * @return {?}
         */
        function () { return this._max; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._max = coerceNumberProperty(value, 100); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtProgressCircleComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () { return this._value; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._value = coerceNumberProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtProgressCircleComponent.prototype, "percent", {
        get: /**
         * @return {?}
         */
        function () {
            return this.value / this.max * 100;
        },
        enumerable: true,
        configurable: true
    });
    NtProgressCircleComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-progress-circle',
                    template: "<div class=\"nt-progress-circle-meter\" [class.half]=\"percent < 50\"> <div class=\"nt-circle-half nt-circle-left\" [style.transform]=\"'rotate(' + (percent > 100 ? 100 : percent) * 3.6 + 'deg)'\"></div> <div class=\"nt-circle-half nt-circle-right\"></div> </div> <div class=\"nt-progress-circle-inner\"><ng-content></ng-content></div> ",
                    host: {
                        '[class]': '["nt-progress-circle", color, size, class].join(" ")'
                    }
                },] },
    ];
    /** @nocollapse */
    NtProgressCircleComponent.propDecorators = {
        "max": [{ type: Input },],
        "value": [{ type: Input },],
        "size": [{ type: Input },],
        "color": [{ type: Input },],
        "class": [{ type: Input },],
    };
    return NtProgressCircleComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtProgressComponent = /** @class */ (function () {
    function NtProgressComponent() {
        this._max = 100;
        this._value = 0;
        this.size = 'medium';
        this.color = '';
        this.class = '';
    }
    Object.defineProperty(NtProgressComponent.prototype, "max", {
        get: /**
         * @return {?}
         */
        function () { return this._max; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._max = coerceNumberProperty(value, 100); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtProgressComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () { return this._value; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._value = coerceNumberProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtProgressComponent.prototype, "percent", {
        get: /**
         * @return {?}
         */
        function () {
            var /** @type {?} */ percent = this.value / this.max * 100;
            return percent > 100 ? 100 : percent;
        },
        enumerable: true,
        configurable: true
    });
    NtProgressComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-progress',
                    template: "<span class=\"progress-meter\" [style.width.%]=\"percent > 100 ? 100 : percent\"> <p class=\"progress-meter-text\"><ng-content></ng-content></p> </span> ",
                    host: {
                        '[class]': '["progress", color, size, class].join(" ")'
                    }
                },] },
    ];
    /** @nocollapse */
    NtProgressComponent.propDecorators = {
        "max": [{ type: Input },],
        "value": [{ type: Input },],
        "size": [{ type: Input },],
        "color": [{ type: Input },],
        "class": [{ type: Input },],
    };
    return NtProgressComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NtProgressModule = /** @class */ (function () {
    function NtProgressModule() {
    }
    NtProgressModule.decorators = [
        { type: NgModule, args: [{
                    exports: [NtProgressComponent, NtProgressCircleComponent],
                    declarations: [NtProgressComponent, NtProgressCircleComponent]
                },] },
    ];
    return NtProgressModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { NtProgressModule, NtProgressComponent, NtProgressCircleComponent };
//# sourceMappingURL=progress.js.map
